package hpdos.services;

import java.io.IOException;

import com.github.benmanes.caffeine.cache.Cache;
import com.ibm.darpc.DaRPCServerEndpoint;
import com.ibm.darpc.DaRPCServerEvent;
import com.ibm.darpc.DaRPCService;

import hpdos.handlers.NetworkHandler;
import hpdos.protocol.InvalidationRequest;
import hpdos.protocol.InvalidationResponse;
import hpdos.protocol.InvalidationRpcProtocol;

public class InvalidationService extends InvalidationRpcProtocol implements DaRPCService<InvalidationRequest, InvalidationResponse>{
    // Cache<String, String> cache;
    NetworkHandler networkHandler;
    public InvalidationService(NetworkHandler networkHandler)
    {
        this.networkHandler  = networkHandler;
    }
    @Override
    public void processServerEvent(DaRPCServerEvent<InvalidationRequest, InvalidationResponse> event) throws IOException {
        System.out.println("Got Invalidation Request");
        InvalidationRequest request = event.getReceiveMessage();
        InvalidationResponse response = event.getSendMessage();
        try
        {
            byte[] key = request.getKey();
            networkHandler.cache.invalidate(new String(key));
            response.setAck(1);
        }
        catch(Exception e)
        {
            e.printStackTrace();
            response.setAck(0);
        }
        event.triggerResponse();
    }
      
    public void open(DaRPCServerEndpoint<InvalidationRequest,InvalidationResponse> serverEp)
    {
        System.out.println("Recieved New Connection for invalidation");
        try{
            System.out.println(serverEp.getDstAddr());
        }catch(Exception e){}
    }
    public void close(DaRPCServerEndpoint<InvalidationRequest,InvalidationResponse> serverEp)
    {
        System.out.println("Closing Connection for invalidation");
        try{
            System.out.println(serverEp.getDstAddr());
        }catch(Exception e){}
    }
}
